/*
 *
 * Copyright (C) 2007 Tomasz Ostrowski ( http://ostry.w.szu.pl )
 *
 * This file is part of Free GG.
 *
 * Free GG is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Free GG is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Free GG; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */


//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "SetStatusThread.h"
#include "Main.h"
#include "GaduThread.h"
#pragma package(smart_init)

extern TGaduThread *gg_thread;
AnsiString status;

//---------------------------------------------------------------------------

__fastcall TSetStatusThread::TSetStatusThread(bool CreateSuspended)
    : TThread(CreateSuspended)
{
	FreeOnTerminate = true; // Set FreeOnTerminate to true if you dont want to explicitly destroy threads after they finish executing
    OnTerminate = MainForm->EnableTmrPluginPoll;  //after execute, before the thread is destroyed
                                        //called in the context of the main VCL thread
}
//---------------------------------------------------------------------------
void __fastcall TSetStatusThread::Execute()
{
    char buf[256];
    AnsiString buf2;
    TWinSocketStream *SS;
    TClientSocket *S = new TClientSocket (NULL);

    S -> Host = "192.168.2.10"; ///< \todo
    S -> Port = 7777;
    S -> ClientType = ctBlocking;
    try
    {
            S -> Open();
    }
    catch (Exception *E)
    {
            Terminate();
            delete S;
            return;
    }

    try
    {
        SS = new TWinSocketStream (S -> Socket, 60000); //timeout = 60s

        int count;
        while ( (count = SS -> Read (buf, 256)) > 0 ) buf2 += ((AnsiString)buf).SubString (1, count);
        if(buf2.Length())
        {
            status = buf2 + FormatDateTime(" hh:nn", Now());
            Synchronize(&SetStatus);
        }
    }
    __finally
    {
        Terminate();
        delete S;
        delete SS;
    }
}
//---------------------------------------------------------------------------

void __fastcall TSetStatusThread::SetStatus()
{
    int id;
    if (MainForm -> status0 -> Checked) id = MainForm -> status0 -> Tag; else
    if (MainForm -> status1 -> Checked) id = MainForm -> status1 -> Tag; else
    if (MainForm -> status2 -> Checked) id = MainForm -> status2 -> Tag; else
    if (MainForm -> status3 -> Checked) id = MainForm -> status3 -> Tag;
    gg_thread -> ChangeStatus (id, status);
    MainForm -> Opis1 -> Checked = (status != "");
    
}