/*
 *
 * Copyright (C) 2003 Sadysta ( http://sadysta.ath.cx )
 * Copyright (C) 2007 Tomasz Ostrowski ( http://ostry.w.szu.pl ) - modified from 1.8.9 source
 *
 * This file is part of Free GG.
 *
 * Free GG is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Free GG is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Free GG; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Transfer.h"
#include "TransferThread.h"
#include "Settings.h"

#include <winsock.h>
#include <FileCtrl.hpp>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TTransferForm *TransferForm;
//---------------------------------------------------------------------------
__fastcall TTransferForm::TTransferForm(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TTransferForm::FormCreate(TObject *Sender)
{
        AnsiString GGDir = "";
        char buf[MAX_PATH];
        SHGetFolderPath (NULL, CSIDL_PROFILE, NULL, SHGFP_TYPE_CURRENT, buf);
        GGDir = (AnsiString)buf + "\\Free GG";
        config_file = GGDir + "\\transfer.ini";

        CheckBox1 -> Checked = GetPrivateProfileInt ("Transfer", "Enabled", 0, config_file.c_str());
        CheckBox2 -> Checked = GetPrivateProfileInt ("Transfer", "NAT", 0, config_file.c_str());
        CheckBox3 -> Checked = GetPrivateProfileInt ("Transfer", "Forward", 0, config_file.c_str());
        Edit1 -> Text = IntToStr (GetPrivateProfileInt ("Transfer", "Local Port", 1550, config_file.c_str()));
        Edit2 -> Text = IntToStr (GetPrivateProfileInt ("Transfer", "External Port", 0, config_file.c_str()));

        GetPrivateProfileString ("Transfer", "External IP", "", buf, sizeof(buf), config_file.c_str());
        Edit3 -> Text = buf;
        GetPrivateProfileString ("Transfer", "Download Dir", GetCurrentDir().c_str(), buf, sizeof(buf), config_file.c_str());
        Edit4 -> Text = buf;

        if (CheckBox1 -> Checked)
        {
                WSADATA wsa;
                WSAStartup (MAKEWORD(1,0), &wsa);

                sockaddr_in addr;
                int err = 0;

                err += ((server_sock = socket (AF_INET, SOCK_STREAM, 0)) == INVALID_SOCKET);
                memset (&addr, 0, sizeof(addr));
                addr.sin_family = AF_INET;
                addr.sin_addr.S_un.S_addr = INADDR_ANY;
                addr.sin_port = htons ((short)StrToIntDef (TransferForm -> Edit1 -> Text, 0));
                err += bind (server_sock, (sockaddr*)&addr, sizeof(addr));
                if (err == 0)
                {
                        listen (server_sock, 5);

                        TransLog -> Lines -> Add ("Listening for connections on port " + TransferForm -> Edit1 -> Text + "...");

                        TTransferThread *T = new TTransferThread(true);
                        T -> type = TT_PASSIVE_GET_FILE;
                        T -> Resume();
                } else TransLog -> Lines -> Add ("ERROR: Cannot create listening socket.");
        }
}
//---------------------------------------------------------------------------
void __fastcall TTransferForm::Button1Click(TObject *Sender)
{
        Close();
}
//---------------------------------------------------------------------------
void __fastcall TTransferForm::FormDestroy(TObject *Sender)
{
        WritePrivateProfileString ("Transfer", "Enabled", IntToStr(CheckBox1 -> Checked).c_str(), config_file.c_str());
        WritePrivateProfileString ("Transfer", "NAT", IntToStr(CheckBox2 -> Checked).c_str(), config_file.c_str());
        WritePrivateProfileString ("Transfer", "Forward", IntToStr(CheckBox3 -> Checked).c_str(), config_file.c_str());
        WritePrivateProfileString ("Transfer", "Local Port", Edit1 -> Text.c_str(), config_file.c_str());
        WritePrivateProfileString ("Transfer", "External Port", Edit2 -> Text.c_str(), config_file.c_str());
        WritePrivateProfileString ("Transfer", "External IP", Edit3 -> Text.c_str(), config_file.c_str());
        WritePrivateProfileString ("Transfer", "Download Dir", Edit4 -> Text.c_str(), config_file.c_str());
}
//---------------------------------------------------------------------------
void __fastcall TTransferForm::Button2Click(TObject *Sender)
{
        AnsiString Dir;
        if (SelectDirectory ("Wybierz katalog docelowy", "", Dir)) Edit4 -> Text = Dir;
}
//---------------------------------------------------------------------------

